Attribute VB_Name = "modAllplanGetCadElements"
Option Explicit

'Elemente per UserInteraction aus Allplan auslesen
Function UserIntGetCadElements() As NALLCOMSERVERLib.CadElements
Dim objApplication As NALLCOMSERVERLib.AllplApplication
Dim objDocument As NALLCOMSERVERLib.AllplDocument
    On Error GoTo Fehler
    Set objApplication = New NALLCOMSERVERLib.AllplApplication
    Set objDocument = objApplication.ActiveDocument
    Set UserIntGetCadElements = objApplication.ActiveDocument.UserInteraction.GetCadElements
    Exit Function
Fehler:
    If Error = "AllplApplication.FinalConstruct: programm is in menue interaction, to continue terminate menueinteraction" Then
        MsgBox "Bitte Funktion in Allplan beenden", vbCritical, "Fehler"
    End If
    If Error = "CComCollectionManager.ReadCollectionFromArray: Unknown element(s) filtered, will be ignored" Then
        MsgBox "Es wurden unbekannte Elemente ausgewhlt" & vbCrLf & "(Einzelpunkt/Symbolpunkt, Spline, Elementverbindung ...)", vbCritical, "Fehler"
    End If
End Function

'Elemente per ElementFilter aus Allplan auslesen
Function FilterGetCadElements(objCadElementFilter As NALLCOMSERVERLib.CadElementFilter) As NALLCOMSERVERLib.CadElements
Dim objApplication As NALLCOMSERVERLib.AllplApplication
Dim objDocument As NALLCOMSERVERLib.AllplDocument
    On Error GoTo Fehler
    Set objApplication = New NALLCOMSERVERLib.AllplApplication
    Set objDocument = objApplication.ActiveDocument
    Set FilterGetCadElements = objDocument.Select(objCadElementFilter)
Fehler:
If Error = "AllplApplication.FinalConstruct: programm is in menue interaction, to continue terminate menueinteraction" Then
    MsgBox "Bitte Funktion in Allplan beenden", vbCritical, "Fehler"
End If
End Function

'Fgt alle Objekte des Types objFilter der neuen CadElements-Collection zu
Public Function FilterCadElements(objCadElements As NALLCOMSERVERLib.CadElements, objFilter As NALLCOMSERVERLib.CadElement) As NALLCOMSERVERLib.CadElements
Dim objTempCadElements As NALLCOMSERVERLib.CadElements
Dim objCadElement As NALLCOMSERVERLib.CadElement

    Set objTempCadElements = New NALLCOMSERVERLib.CadElements

    For Each objCadElement In objCadElements
        If TypeName(objCadElement) = TypeName(objFilter) Then
            objTempCadElements.Add objCadElement
        End If
    Next
    
    If objTempCadElements.Count > 0 Then Set FilterCadElements = objTempCadElements
End Function
'Polygonobjekte auswahlen
Function GetPolyElements() As NALLCOMSERVERLib.CadElements
Dim objCadElements As NALLCOMSERVERLib.CadElements
Dim objAllPolyElements As NALLCOMSERVERLib.CadElements
Dim objSolidSurface As NALLCOMSERVERLib.CadElements
Dim objCadSurface As NALLCOMSERVERLib.CadSurface
Dim objCadElement As NALLCOMSERVERLib.CadElement
    
    Set objAllPolyElements = New NALLCOMSERVERLib.CadElements
    Set objCadElements = UserIntGetCadElements
        
    If objCadElements Is Nothing Then Exit Function
    If objCadElements.Count = 0 Then Exit Function
        
        For Each objCadElement In objCadElements
        
            If TypeOf objCadElement Is NALLCOMSERVERLib.PolyLine Then
                objAllPolyElements.Add objCadElement
            ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.PolyLine3D Then
                objAllPolyElements.Add objCadElement
            ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Filling Then
                objAllPolyElements.Add objCadElement
            ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Hatch Then
                objAllPolyElements.Add objCadElement
            ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Pattern Then
                objAllPolyElements.Add objCadElement
            ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.CadSurface Then
                objAllPolyElements.Add objCadElement
            ElseIf TypeOf objCadElement Is NALLCOMSERVERLib.Solid Then
                '3DSolid in CadSurface umwandeln
                Set objSolidSurface = Solid2CadSurface(objCadElement)
                For Each objCadSurface In objSolidSurface
                    objAllPolyElements.Add objCadSurface
                Next
            End If
        Next
        
    Set GetPolyElements = objAllPolyElements
End Function

'3DSolid in Surface umwandeln
Function Solid2CadSurface(objSolid As NALLCOMSERVERLib.Solid) As NALLCOMSERVERLib.CadElements
Dim objCadElements As NALLCOMSERVERLib.CadElements
Dim objCadElement As NALLCOMSERVERLib.CadElement
Dim objSurfaceGeometry As NALLCOMSERVERLib.SurfaceGeometry
Dim objCadSurface As NALLCOMSERVERLib.CadSurface
Dim vntPoints As Variant
Dim strLayer As String

    Set objCadElements = New NALLCOMSERVERLib.CadElements
    strLayer = GetLayer(objSolid)
    
    For Each objSurfaceGeometry In objSolid
        Set objCadSurface = New NALLCOMSERVERLib.CadSurface
        objSurfaceGeometry.GetGeometry vntPoints
        objCadSurface.SetGeometry vntPoints
        objCadSurface.Style = objSolid.Style
        Set objCadElement = objCadSurface
        SetLayer objCadElement, strLayer
        objCadElements.Add objCadElement
    Next
    Set Solid2CadSurface = objCadElements
End Function


'Geometrie von Polygonelementen
Function GetPolyGeometry(ByVal objCadElement As NALLCOMSERVERLib.CadElement) As Variant
Dim objPolyLine As NALLCOMSERVERLib.PolyLine
Dim objPolyLine3D As NALLCOMSERVERLib.PolyLine3D
Dim objFilling As NALLCOMSERVERLib.Filling
Dim objHatch As NALLCOMSERVERLib.Hatch
Dim objPattern As NALLCOMSERVERLib.Pattern
Dim objCadSurface As NALLCOMSERVERLib.CadSurface
Dim vntGeometry As Variant
    
    If TypeOf objCadElement Is PolyLine Then
        Set objPolyLine = objCadElement
        objPolyLine.GetGeometry vntGeometry
    ElseIf TypeOf objCadElement Is PolyLine3D Then
        Set objPolyLine3D = objCadElement
        objPolyLine3D.GetGeometry vntGeometry
    ElseIf TypeOf objCadElement Is Filling Then
        Set objFilling = objCadElement
        objFilling.GetGeometry vntGeometry
    ElseIf TypeOf objCadElement Is Hatch Then
        Set objHatch = objCadElement
        objHatch.GetGeometry vntGeometry
    ElseIf TypeOf objCadElement Is Pattern Then
        Set objPattern = objCadElement
        objPattern.GetGeometry vntGeometry
    ElseIf TypeOf objCadElement Is CadSurface Then
        Set objCadSurface = objCadElement
        objCadSurface.GetGeometry vntGeometry
    End If
               
    GetPolyGeometry = vntGeometry
End Function
