Attribute VB_Name = "modAllplanPoly"
Option Explicit

Public Sub CreatePolyObject()
Dim objApplication As NALLCOMSERVERLib.AllplApplication
Dim objDocument As NALLCOMSERVERLib.AllplDocument
Dim objGetCadElements As NALLCOMSERVERLib.CadElements
Dim objSetCadElements As NALLCOMSERVERLib.CadElements
Dim objTempCadElements As NALLCOMSERVERLib.CadElements
Dim objCadElement As NALLCOMSERVERLib.CadElement
Dim objPolyObject As AllplanPolyObj
Dim vntAllPolyObject() As Variant
Dim i As Long
Dim j As Long
Dim k As Long

    On Error GoTo Ende

    Set objApplication = New NALLCOMSERVERLib.AllplApplication
    Set objDocument = objApplication.ActiveDocument
    Set objSetCadElements = New NALLCOMSERVERLib.CadElements
    
    frmAllplanPoly.Visible = False
    
    Set objGetCadElements = GetPolyElements
    If LockAllplan(True) = False Then GoTo Ende
    
    On Error GoTo Weiter
    If objGetCadElements Is Nothing Then GoTo Weiter

    For Each objCadElement In objGetCadElements
        ReDim Preserve vntAllPolyObject(i)
        Set objPolyObject = SetAllplPolyObj(objGetCadElements.Item(i + 1))
        Set vntAllPolyObject(i) = objPolyObject
        i = i + 1
    Next
    
    For j = 0 To UBound(vntAllPolyObject)
        Set objPolyObject = vntAllPolyObject(j)
        Select Case frmAllplanPoly.GlngPolyObj
            Case 0
                If frmAllplanPoly.GblnDividePoly = True Then
                    Set objTempCadElements = SetLine2D(objPolyObject)
                    For k = 1 To objTempCadElements.Count
                        objSetCadElements.Add objTempCadElements.Item(k)
                    Next k
                Else
                    Set objCadElement = SetPolyLine(objPolyObject)
                    If objCadElement Is Nothing Then GoTo NextSelect
                    objSetCadElements.Add objCadElement
                End If
            Case 1
                Set objCadElement = SetFilling(objPolyObject)
                If objCadElement Is Nothing Then GoTo NextSelect
                objSetCadElements.Add objCadElement
            Case 2
                If frmAllplanPoly.GblnDividePoly = True Then
                    Set objTempCadElements = SetLine3D(objPolyObject)
                    For k = 1 To objTempCadElements.Count
                        objSetCadElements.Add objTempCadElements.Item(k)
                    Next k
                Else
                    Set objCadElement = SetPolyLine3D(objPolyObject)
                    If objCadElement Is Nothing Then GoTo NextSelect
                    objSetCadElements.Add objCadElement
                End If
            Case 3
                Set objCadElement = SetCadSurface(objPolyObject)
                If objCadElement Is Nothing Then GoTo NextSelect
                objSetCadElements.Add objCadElement
            Case Else
        End Select
NextSelect:
    Next

    If objSetCadElements.Count > 0 Then objDocument.Create objSetCadElements
Weiter:
    If LockAllplan(False) = False Then GoTo Ende
Ende:
    frmAllplanPoly.Visible = True
End Sub

Function SetAllplPolyObj(objCadElement As NALLCOMSERVERLib.CadElement) As AllplanPolyObj
Dim objAllplanPolyObj As AllplanPolyObj
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntPoints As Variant
Dim strLayer As String

    Set objAllplanPolyObj = New AllplanPolyObj
    
    Set objStyle = GetStyle(objCadElement)
    vntPoints = GetPolyGeometry(objCadElement)
    strLayer = GetLayer(objCadElement)
    
    objAllplanPolyObj.SetGeometry vntPoints
    objAllplanPolyObj.SetLayer strLayer
    objAllplanPolyObj.SetStyle objStyle
    
    If frmAllplanPoly.GblnClosePoly = True Then objAllplanPolyObj.ClosePoly
    If frmAllplanPoly.GblnZValue = True Then objAllplanPolyObj.ZValue (frmAllplanPoly.GdblZValue)
    
    Set SetAllplPolyObj = objAllplanPolyObj

End Function


Function SetFilling(objAllplanPoly As AllplanPolyObj) As NALLCOMSERVERLib.CadElement
Dim objFilling As NALLCOMSERVERLib.Filling
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntPoints As Variant
Dim strLayer As String
    
    On Error GoTo Fehler
    
    Set objFilling = New NALLCOMSERVERLib.Filling
    
    objAllplanPoly.RemoveMultiPoints2D

    If objAllplanPoly.AllPointsInLine = True Then GoTo Fehler
    
    objAllplanPoly.GetGeometry2D vntPoints
    objAllplanPoly.GetLayer strLayer
    objAllplanPoly.GetStyle objStyle
    
    If UBound(vntPoints, 2) < 2 Then GoTo Fehler
    
    objFilling.SetGeometry vntPoints
    
    objFilling.Color = frmAllplanPoly.GlngColor
    
    If frmAllplanPoly.GblnActiveLayer = True Then
        SetLayer objFilling, frmAllplanPoly.GstrLayer
    Else
        SetLayer objFilling, strLayer
    End If
    Set SetFilling = objFilling
    Exit Function
Fehler:

End Function

Function SetPolyLine(objAllplanPoly As AllplanPolyObj) As NALLCOMSERVERLib.CadElement
Dim objPolyLine As NALLCOMSERVERLib.PolyLine
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntPoints As Variant
Dim strLayer As String
    
    On Error GoTo Fehler
    
    Set objPolyLine = New NALLCOMSERVERLib.PolyLine
    
    objAllplanPoly.RemoveMultiPoints2D
    
    If objAllplanPoly.Count < 3 Then objAllplanPoly.OpenPoly
    
    objAllplanPoly.GetGeometry2D vntPoints
    objAllplanPoly.GetLayer strLayer
    objAllplanPoly.GetStyle objStyle

    objPolyLine.SetGeometry vntPoints
    
    If frmAllplanPoly.GblnActiveStyle = True Then
        SetStyle objPolyLine, frmAllplanPoly.GobjStyle
    Else
        SetStyle objPolyLine, objStyle
    End If
    
    If frmAllplanPoly.GblnActiveLayer = True Then
        SetLayer objPolyLine, frmAllplanPoly.GstrLayer
    Else
        SetLayer objPolyLine, strLayer
    End If
    Set SetPolyLine = objPolyLine
    Exit Function
Fehler:

End Function

Function SetLine2D(objAllplanPoly As AllplanPolyObj) As NALLCOMSERVERLib.CadElements
Dim objAllLines2D As NALLCOMSERVERLib.CadElements
Dim objLine2D As NALLCOMSERVERLib.PolyLine
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntAllPoints As Variant
Dim vntPoints(1, 1) As Double
Dim strLayer As String
Dim i As Long
Dim j As Long
    
    On Error GoTo Fehler
    
    Set objAllLines2D = New NALLCOMSERVERLib.CadElements

    objAllplanPoly.GetGeometry2D vntAllPoints
    objAllplanPoly.GetLayer strLayer
    objAllplanPoly.GetStyle objStyle

    For i = 0 To UBound(vntAllPoints, 2) - 1
        Set objLine2D = New NALLCOMSERVERLib.PolyLine
        
        For j = 0 To 1
            vntPoints(0, j) = vntAllPoints(0, i + j)
            vntPoints(1, j) = vntAllPoints(1, i + j)
        Next j
    
        objLine2D.SetGeometry vntPoints
    
        If frmAllplanPoly.GblnActiveStyle = True Then
            SetStyle objLine2D, frmAllplanPoly.GobjStyle
        Else
            SetStyle objLine2D, objStyle
        End If
        
        If frmAllplanPoly.GblnActiveLayer = True Then
            SetLayer objLine2D, frmAllplanPoly.GstrLayer
        Else
            SetLayer objLine2D, strLayer
        End If
        
        objAllLines2D.Add objLine2D
    Next i
    
    Set SetLine2D = objAllLines2D
    Exit Function
Fehler:

End Function

Function SetPolyLine3D(objAllplanPoly As AllplanPolyObj) As NALLCOMSERVERLib.CadElement
Dim objPolyLine3D As NALLCOMSERVERLib.PolyLine3D
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntPoints As Variant
Dim strLayer As String
    
    On Error GoTo Fehler
    
    Set objPolyLine3D = New NALLCOMSERVERLib.PolyLine3D
    
    objAllplanPoly.Getgeometry3D vntPoints
    objAllplanPoly.GetLayer strLayer
    objAllplanPoly.GetStyle objStyle
    
    objPolyLine3D.SetGeometry vntPoints
    
    If frmAllplanPoly.GblnActiveStyle = True Then
        SetStyle objPolyLine3D, frmAllplanPoly.GobjStyle
    Else
        SetStyle objPolyLine3D, objStyle
    End If
    
    If frmAllplanPoly.GblnActiveLayer = True Then
        SetLayer objPolyLine3D, frmAllplanPoly.GstrLayer
    Else
        SetLayer objPolyLine3D, strLayer
    End If
    Set SetPolyLine3D = objPolyLine3D
    Exit Function
Fehler:

End Function

Function SetLine3D(objAllplanPoly As AllplanPolyObj) As NALLCOMSERVERLib.CadElements
Dim objAllLines3D As NALLCOMSERVERLib.CadElements
Dim objLine3D As NALLCOMSERVERLib.PolyLine3D
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntAllPoints As Variant
Dim vntPoints(2, 1) As Double
Dim strLayer As String
Dim i As Long
Dim j As Long
    
    On Error GoTo Fehler
    
    Set objAllLines3D = New NALLCOMSERVERLib.CadElements

    objAllplanPoly.Getgeometry3D vntAllPoints
    objAllplanPoly.GetLayer strLayer
    objAllplanPoly.GetStyle objStyle

    For i = 0 To UBound(vntAllPoints, 2) - 1
    
    Set objLine3D = New NALLCOMSERVERLib.PolyLine3D
    
        For j = 0 To 1
            vntPoints(0, j) = vntAllPoints(0, i + j)
            vntPoints(1, j) = vntAllPoints(1, i + j)
            vntPoints(2, j) = vntAllPoints(2, i + j)
        Next j
    
        objLine3D.SetGeometry vntPoints
    
        If frmAllplanPoly.GblnActiveStyle = True Then
            SetStyle objLine3D, frmAllplanPoly.GobjStyle
        Else
            SetStyle objLine3D, objStyle
        End If
        
        If frmAllplanPoly.GblnActiveLayer = True Then
            SetLayer objLine3D, frmAllplanPoly.GstrLayer
        Else
            SetLayer objLine3D, strLayer
        End If
        
        objAllLines3D.Add objLine3D
    Next i
    
    Set SetLine3D = objAllLines3D
    Exit Function
Fehler:

End Function

Function SetCadSurface(objAllplanPoly As AllplanPolyObj) As NALLCOMSERVERLib.CadElement
Dim objCadSurface As NALLCOMSERVERLib.CadSurface
Dim objStyle As NALLCOMSERVERLib.Style
Dim vntPoints As Variant
Dim strLayer As String
    
    On Error GoTo Fehler
    
    Set objCadSurface = New NALLCOMSERVERLib.CadSurface
    
    objAllplanPoly.Getgeometry3D vntPoints
    objAllplanPoly.GetLayer strLayer
    objAllplanPoly.GetStyle objStyle
    
    If UBound(vntPoints, 2) < 2 Then Exit Function
    
    objCadSurface.SetGeometry vntPoints
    
    If frmAllplanPoly.GblnActiveStyle = True Then
        SetStyle objCadSurface, frmAllplanPoly.GobjStyle
    Else
        SetStyle objCadSurface, objStyle
    End If
    
    If frmAllplanPoly.GblnActiveLayer = True Then
        SetLayer objCadSurface, frmAllplanPoly.GstrLayer
    Else
        SetLayer objCadSurface, strLayer
    End If
    Set SetCadSurface = objCadSurface
    Exit Function
Fehler:

End Function
